
# disabled in the nether since you'd spawn on the roof
execute if dimension minecraft:the_nether run return fail

# makes sure this is the right kind of block
execute unless block ~ ~ ~ #lodeways:gateway_base run return fail

#checks for a position on the held item
execute unless data entity @s SelectedItem.components."minecraft:lodestone_tracker".target.pos unless items entity @s weapon.mainhand minecraft:recovery_compass run return fail


# follow this format for additional dimensions
execute unless dimension minecraft:overworld as @s[nbt={SelectedItem:{components:{"minecraft:lodestone_tracker":{target:{dimension:"minecraft:overworld"}}}}}] run return fail
execute unless dimension minecraft:the_nether as @s[nbt={SelectedItem:{components:{"minecraft:lodestone_tracker":{target:{dimension:"minecraft:the_nether"}}}}}] run return fail
execute unless dimension minecraft:the_end as @s[nbt={SelectedItem:{components:{"minecraft:lodestone_tracker":{target:{dimension:"minecraft:the_end"}}}}}] run return fail




# the lodeway_building tag is temporary and exists to make sure nothing goes wrong. it's probably not neccesary but why mess with it
summon minecraft:marker ~0.5 ~ ~0.5 {data:{is_lodeway:1b, lodeway_building:1b}}

# recovery compass flag
execute if items entity @s weapon.mainhand minecraft:recovery_compass run data modify entity @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] data.recovery set value 1b


# add the direction of the end rod to the marker
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] if block ~ ~ ~ #lodeways:gateway_base[facing=up] run data modify entity @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] data.facing set value "up"
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] if block ~ ~ ~ #lodeways:gateway_base[facing=down] run data modify entity @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] data.facing set value "down"
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] if block ~ ~ ~ #lodeways:gateway_base[facing=north] run data modify entity @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] data.facing set value "north"
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] if block ~ ~ ~ #lodeways:gateway_base[facing=south] run data modify entity @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] data.facing set value "south"
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] if block ~ ~ ~ #lodeways:gateway_base[facing=east] run data modify entity @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] data.facing set value "east"
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] if block ~ ~ ~ #lodeways:gateway_base[facing=west] run data modify entity @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] data.facing set value "west"

# setups:
# 1: check for obstructions, and then return and destroy yourself if there is one.
# 2: place the gateway.
# 3: copy the position from the compass to the gateway.
# 4: summon the block display.

# setup for "up"
execute as @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"up"}},limit=1,sort=nearest] at @s unless block ~ ~1 ~ #minecraft:replaceable run return run kill @s
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"up"}},limit=1,sort=nearest] run setblock ~ ~1 ~ minecraft:end_gateway
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"up"}},limit=1,sort=nearest] run data modify block ~ ~1 ~ exit_portal set from entity @s SelectedItem.components.minecraft:lodestone_tracker.target.pos
execute unless items entity @s weapon.mainhand minecraft:recovery_compass at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"up"}},limit=1,sort=nearest] run summon minecraft:block_display ~ ~ ~ {transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],translation:[-0.5f,0.75f,-0.5f]},block_state:{Name:"minecraft:polished_tuff_wall"}}
execute if items entity @s weapon.mainhand minecraft:recovery_compass at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"up"}},limit=1,sort=nearest] run summon minecraft:block_display ~ ~ ~ {transformation:{left_rotation:[0f,0f,0f,1f],right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],translation:[-0.5f,0.75f,-0.5f]},block_state:{Name:"minecraft:soul_lantern"}}

# setup for "down"
execute as @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"down"}},limit=1,sort=nearest] at @s unless block ~ ~-1 ~ #minecraft:replaceable run return run kill @s
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"down"}},limit=1,sort=nearest] run setblock ~ ~-1 ~ minecraft:end_gateway
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"down"}},limit=1,sort=nearest] run data modify block ~ ~-1 ~ exit_portal set from entity @s SelectedItem.components.minecraft:lodestone_tracker.target.pos
execute unless items entity @s weapon.mainhand minecraft:recovery_compass at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"down"}},limit=1,sort=nearest] run summon minecraft:block_display ~ ~ ~ {transformation:{left_rotation:{angle:-3.14159, axis:[I;0,0,1]},right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],translation:[0.5f,0.25f,-0.5f]},block_state:{Name:"minecraft:polished_tuff_wall"}}
execute if items entity @s weapon.mainhand minecraft:recovery_compass at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"down"}},limit=1,sort=nearest] run summon minecraft:block_display ~ ~ ~ {transformation:{left_rotation:{angle:-3.14159, axis:[I;0,0,1]},right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],translation:[0.5f,0.25f,-0.5f]},block_state:{Name:"minecraft:soul_lantern"}}

# setup for "north"
execute as @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"north"}},limit=1,sort=nearest] at @s unless block ~ ~ ~-1 #minecraft:replaceable run return run kill @s
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"north"}},limit=1,sort=nearest] run setblock ~ ~ ~-1 minecraft:end_gateway
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"north"}},limit=1,sort=nearest] run data modify block ~ ~ ~-1 exit_portal set from entity @s SelectedItem.components.minecraft:lodestone_tracker.target.pos
execute unless items entity @s weapon.mainhand minecraft:recovery_compass at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"north"}},limit=1,sort=nearest] run summon minecraft:block_display ~ ~ ~ {transformation:{left_rotation:{angle:-1.5708, axis:[I;1,0,0]},right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],translation:[-0.5f,0f,-0.25f]},block_state:{Name:"minecraft:polished_tuff_wall"}}
execute if items entity @s weapon.mainhand minecraft:recovery_compass at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"north"}},limit=1,sort=nearest] run summon minecraft:block_display ~ ~ ~ {transformation:{left_rotation:{angle:-1.5708, axis:[I;1,0,0]},right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],translation:[-0.5f,0f,-0.25f]},block_state:{Name:"minecraft:soul_lantern"}}


# setup for "south"
execute as @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"south"}},limit=1,sort=nearest] at @s unless block ~ ~ ~1 #minecraft:replaceable run return run kill @s
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"south"}},limit=1,sort=nearest] run setblock ~ ~ ~1 minecraft:end_gateway
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"south"}},limit=1,sort=nearest] run data modify block ~ ~ ~1 exit_portal set from entity @s SelectedItem.components.minecraft:lodestone_tracker.target.pos
execute unless items entity @s weapon.mainhand minecraft:recovery_compass at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"south"}},limit=1,sort=nearest] run summon minecraft:block_display ~ ~ ~ {transformation:{left_rotation:{angle:1.5708, axis:[I;1,0,0]},right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],translation:[-0.5f,1f,0.25f]},block_state:{Name:"minecraft:polished_tuff_wall"}}
execute if items entity @s weapon.mainhand minecraft:recovery_compass at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"south"}},limit=1,sort=nearest] run summon minecraft:block_display ~ ~ ~ {transformation:{left_rotation:{angle:1.5708, axis:[I;1,0,0]},right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],translation:[-0.5f,1f,0.25f]},block_state:{Name:"minecraft:soul_lantern"}}

# setup for "east"
execute as @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"east"}},limit=1,sort=nearest] at @s unless block ~1 ~ ~ #minecraft:replaceable run return run kill @s
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"east"}},limit=1,sort=nearest] run setblock ~1 ~ ~ minecraft:end_gateway
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"east"}},limit=1,sort=nearest] run data modify block ~1 ~ ~ exit_portal set from entity @s SelectedItem.components.minecraft:lodestone_tracker.target.pos
execute unless items entity @s weapon.mainhand minecraft:recovery_compass at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"east"}},limit=1,sort=nearest] run summon minecraft:block_display ~ ~ ~ {transformation:{left_rotation:{angle:-1.5708, axis:[I;0,0,1]},right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],translation:[0.25f,1f,-0.5f]},block_state:{Name:"minecraft:polished_tuff_wall"}}
execute if items entity @s weapon.mainhand minecraft:recovery_compass at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"east"}},limit=1,sort=nearest] run summon minecraft:block_display ~ ~ ~ {transformation:{left_rotation:{angle:-1.5708, axis:[I;0,0,1]},right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],translation:[0.25f,1f,-0.5f]},block_state:{Name:"minecraft:soul_lantern"}}

# setup for "west"
execute as @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"west"}},limit=1,sort=nearest] at @s unless block ~-1 ~ ~ #minecraft:replaceable run return run kill @s
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"west"}},limit=1,sort=nearest] run setblock ~-1 ~ ~ minecraft:end_gateway
execute at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"west"}},limit=1,sort=nearest] run data modify block ~-1 ~ ~ exit_portal set from entity @s SelectedItem.components.minecraft:lodestone_tracker.target.pos
execute unless items entity @s weapon.mainhand minecraft:recovery_compass at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"west"}},limit=1,sort=nearest] run summon minecraft:block_display ~ ~ ~ {transformation:{left_rotation:{angle:1.5708, axis:[I;0,0,1]},right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],translation:[-0.25f,0f,-0.5f]},block_state:{Name:"minecraft:polished_tuff_wall"}}
execute if items entity @s weapon.mainhand minecraft:recovery_compass at @e[type=minecraft:marker,nbt={data:{lodeway_building:1b,facing:"west"}},limit=1,sort=nearest] run summon minecraft:block_display ~ ~ ~ {transformation:{left_rotation:{angle:1.5708, axis:[I;0,0,1]},right_rotation:[0f,0f,0f,1f],scale:[1f,1f,1f],translation:[-0.25f,0f,-0.5f]},block_state:{Name:"minecraft:soul_lantern"}}



# play a sound and give the advancement because it worked!
playsound minecraft:block.vault.open_shutter block @a ~ ~ ~
execute unless items entity @s weapon.mainhand minecraft:recovery_compass run advancement grant @s only lodeways:build_gateway
execute if items entity @s weapon.mainhand minecraft:recovery_compass run advancement grant @s only lodeways:build_recovery_gateway

# take away a compass
data modify entity @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] data.compass set from entity @s SelectedItem
data modify entity @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] data.compass.count set value 1
item modify entity @s weapon.mainhand lodeways:reduce_stack

# remove the tag that says things are in progress
data remove entity @e[type=minecraft:marker,nbt={data:{lodeway_building:1b}},limit=1,sort=nearest] data.lodeway_building